#include <cstdlib>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <errno.h>
#include <time.h>
#include <semaphore.h>
#include <map>

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>

using namespace std;

long branchId;
int port;
int bankaSocket;
map<int, int> bank_sockets;
vector<int> clients;
pthread_t client_thread;
int amount = 10000;
std::vector<pthread_t> bank_threads;

typedef struct message {
	int from;
	int operation;
	int value;
	timeval sendTime;
	timeval recvTime;
	int sequence;
} MESSAGE;

pthread_mutex_t bank_mutex;
pthread_mutex_t other_mutex;
pthread_mutex_t log_mutex;

std::vector<MESSAGE> other1;
std::vector<MESSAGE> other2;
int expected_other1 = 0;
int expected_other2 = 0;
int sequence_num1 = 0;
int sequence_num2 = 0;
int other1_id;
int other2_id;
int count = 0;
ofstream branchLog;
string fileLogBranch;

int globalMoney;
bool sentMarker = false;

bool globalState = false;
bool setGlobal = false;

map<int, bool> marked_chanels;

struct packet {
	u_int32_t branchId;
	u_int8_t operation;
	u_int32_t value;
	u_int32_t send_at_sec;
	u_int32_t send_at_usec;
};

struct RequestGlobalStatue {
	int request;
	timeval casOdeslani;
	timeval casPrijeti;
	int currentMoney;
};

struct BranchInfo {
	int port;
	int idBranch;
};

struct Branch {
	struct sockaddr_in remote_addr;
	int branchSocket;
	timeval casOdeslani;
	int port;
	int idBranch;
};

std::vector<MESSAGE> queueMessage;
vector<Branch> branches;

timeval getTime() {
	timeval cas;
	gettimeofday(&cas, NULL);
	return cas;
}

string timevalToString(timeval time) {
	stringstream ss;
	ss << time.tv_sec << "." << time.tv_usec;
	return ss.str();
}

string numberToString(int number) {
	stringstream ss;
	ss << number;
	return ss.str();
}

string timeToString(timeval cas) {
	stringstream ss;
	ss << cas.tv_sec << "." << cas.tv_usec;
	return ss.str();
}

void writeToLog(MESSAGE operation) {
	pthread_mutex_lock(&log_mutex);
	branchLog.open(fileLogBranch.c_str(), std::ios_base::app);
	branchLog << "- src: {p: P" << operation.from << ", ts: "
			<< timeToString(operation.sendTime) << "}\n";
	//<< (int)operation.sendTime.tv_sec - (int)operation.sendTime.tv_usec << "}\n";
	branchLog << "  dst: {p: P" << branchId << ", ts: "
			<< timeToString(operation.recvTime) //(int)operation.recvTime.tv_sec - (int)operation.recvTime.tv_usec
			<< "}\n";
	branchLog << "  data: '" << operation.operation << ";" << operation.sequence
			<< "'\n";
	branchLog.close();
	pthread_mutex_unlock(&log_mutex);
}

void writeToGlobalStartLog(RequestGlobalStatue request, int idBranch) {
	pthread_mutex_lock(&log_mutex);
	branchLog.open(fileLogBranch.c_str(), std::ios_base::app);
	branchLog << "- src: {p: BANK, ts: " << timeToString(request.casOdeslani)
			<< "}\n";
	//<< (int)operation.sendTime.tv_sec - (int)operation.sendTime.tv_usec << "}\n";
	branchLog << "  dst: {p: P" << idBranch << ", ts: "
			<< timeToString(request.casPrijeti) //(int)operation.recvTime.tv_sec - (int)operation.recvTime.tv_usec
			<< "}\n";
	branchLog << "  color: '#FF0000'\n";
	branchLog << "  data: '" << request.request << ";" << 0 << "'\n";
	branchLog.close();
	pthread_mutex_unlock(&log_mutex);
}

void writeToMarkerLog(MESSAGE request, int idBranch) {
	pthread_mutex_lock(&log_mutex);
	branchLog.open(fileLogBranch.c_str(), std::ios_base::app);
	branchLog << "- src: {p: P" << request.from << ", ts: "
			<< timeToString(request.sendTime) << "}\n";
	//<< (int)operation.sendTime.tv_sec - (int)operation.sendTime.tv_usec << "}\n";
	branchLog << "  dst: {p: P" << idBranch << ", ts: "
			<< timeToString(request.recvTime) //(int)operation.recvTime.tv_sec - (int)operation.recvTime.tv_usec
			<< "}\n";
	branchLog << "  color: '#FF0000'\n";
	branchLog << "  data: 'MARKER'\n";
	branchLog.close();
	pthread_mutex_unlock(&log_mutex);
}

void observer_init() {
	map<int, int>::iterator iterator;
	for (iterator = bank_sockets.begin(); iterator != bank_sockets.end();
			iterator++)
		marked_chanels.insert(
				map<int, bool>::value_type((*iterator).first, false));
}

bool is_marked_all_chanels() {
	//zjisteni jesli jsou vsechny kanaly v marking stavu
	map<int, bool>::iterator iterator;
	for (iterator = marked_chanels.begin(); iterator != marked_chanels.end();
			iterator++) {
		if (!(*iterator).second)
			return false;
	}

	return true;
}

void *start_listener(void *args) {
	int *pom = (int *) args;
	int client_sock = *pom;
	delete pom;

	while (1) {

		if (is_marked_all_chanels() && sentMarker) {

//			message.recvTime = getTime();
//			writeToLog (message);
//			amount += message.value;
			//globalMoney += message.value;

			RequestGlobalStatue request;
			request.currentMoney = globalMoney;
			request.casOdeslani = getTime();
			request.request = branchId;

			send(bankaSocket, &request, sizeof(RequestGlobalStatue), 0);

			cout << "Send global state to bank\n";

			globalState = false;
			sentMarker = false;
			setGlobal = false;
			globalMoney = 0;
			count = 0;
			map<int, bool>::iterator iterator;
			for (iterator = marked_chanels.begin();
					iterator != marked_chanels.end(); iterator++)
				(*iterator).second = false;

		}

		MESSAGE message;
		if (recv(client_sock, &message, sizeof(MESSAGE), 0)
				!= sizeof(MESSAGE)) {
			//printf("Chyba pri prijmani zpravy - socket %d\n",client_sock);
			exit(1);
		}

		if (message.operation == -1 && count != 2) {

			message.recvTime = getTime();
			writeToMarkerLog(message, branchId);

			if (!setGlobal) {
				observer_init();
				setGlobal = true;
				cout << "Setting global state\n";
				globalState = true;
				pthread_mutex_lock(&bank_mutex);
				globalMoney = amount;
				pthread_mutex_unlock(&bank_mutex);
			}
			// for the second and third process
			//			cout << "Receive a MARKER from the other branch seq "
			//					<< message.sequence << "\n";
			//cout << "PROCESSING SEQ - " << message.sequence << "\n";
			marked_chanels[message.from] = true;
			count++;
			if (count != 2)
				message.operation = 0;
		} else {
			pthread_mutex_lock(&other_mutex);
			if (message.from == other1_id) {
				other1.push_back(message);
			} else {
				other2.push_back(message);
			}
			pthread_mutex_unlock(&other_mutex);
		}

//		pthread_mutex_lock(&other_mutex);
//		if (message.from == other1_id) {
//			other1.push_back(message);
//		} else {
//			other2.push_back(message);
//		}

//		cout << "vkladam do fronty od " << message.from << "\n";
//		cout << "vkladam seq - " << message.sequence << "\n";
		//queueMessage.push_back(message);

	}
	return 0;
}

void *server_thread_run(void *args) {
	int srv = socket(AF_INET, SOCK_STREAM, 0);
	if (srv < 0) {
		cout << "Creating socket failed\n";
	}

	sockaddr_in serverInfo;
	serverInfo.sin_family = PF_INET;
	serverInfo.sin_port = htons(port);
	serverInfo.sin_addr.s_addr = INADDR_ANY;

	// bind to a server socket
	if (bind(srv, (struct sockaddr *) &serverInfo, sizeof(sockaddr_in)) < 0) {
		cout << "Error occurs while binding to server socket\n";
	}

	// listen on server socket
	if (listen(srv, 10) < 0) {
		cout << "Error occurs while listening on server socket\n";
	}

	pthread_t thread_listener;
	int *client_socket;
	while (true) {

		sockaddr_in client_addr;
		socklen_t sock_addr_len;

		client_socket = new int;
		*client_socket = accept(srv, (sockaddr *) &client_addr, &sock_addr_len);

		if (*client_socket > 0) {
			pthread_create(&thread_listener, NULL, &start_listener,
					client_socket);
			bank_threads.push_back(thread_listener);
		}

		sleep(1);
	}

	return NULL;
}

void client_connect(int port, int id) {
	char ip[32] = "127.0.0.1";
	int *socket_pom = new int;
	int sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		printf("Chyba pri vytvareni socketu.\n");
		exit(1);
	}

	sockaddr_in sock_addr;
	sock_addr.sin_family = AF_INET;
	sock_addr.sin_addr.s_addr = inet_addr(ip);
	sock_addr.sin_port = htons(port);

	if (connect(sock, (sockaddr *) &sock_addr, sizeof(sockaddr_in)) < 0) {
		printf("Chyba pri spojovani s %s:%d socket %d\n", ip, port, sock);
		exit(1);
	}

	clients.push_back(sock);

	pthread_t listener_thread;
	*socket_pom = sock;

	pthread_create(&listener_thread, NULL, &start_listener, socket_pom);
	bank_threads.push_back(listener_thread);
	bank_sockets[id] = sock;
}

void client_parse_and_connect() {

	for (std::vector<Branch>::iterator it = branches.begin();
			it != branches.end(); it++) {

		// connect to another branch
		client_connect((*it).port, (*it).idBranch);
		cout << "Connected to the other branch ID - " << (*it).idBranch
				<< ".\n";
	}
}

void packet_send(int c, int operation, int value) {
	MESSAGE message;

	message.value = value;
	message.operation = operation;
	message.sendTime = getTime();
	message.from = branchId;

	map<int, int>::iterator iterator;

	int chanel_id = 0;

	//vyber id pobocky podle socketu
	for (iterator = bank_sockets.begin(); iterator != bank_sockets.end();
			iterator++)
		if (c == (*iterator).second) {
			chanel_id = (*iterator).first;
			break;
		}

	//podle id pobocky zvednu seq num
	if (chanel_id == other1_id) {
		message.sequence = sequence_num1;
		sequence_num1++;
	} else {
		message.sequence = sequence_num2;
		sequence_num2++;
	}

	if (send(c, &message, sizeof(MESSAGE), MSG_DONTWAIT) < 0) {
		cout << "Error occurs while sending packet\n";
	}
}

void *client_thread_run(void *arg) {

	while (true) {

		if (globalState && !sentMarker) {

			//send MARKER to all branch
			MESSAGE message;
			message.operation = -1;
			message.from = branchId;
			//message.sequence = seq;
			message.sendTime = getTime();
			map<int, int>::iterator iterator;

			int chanel_id = 0;
			for (unsigned int i = 0; i < clients.size(); i++) {

//				//vyber id pobocky podle socketu
//				for (iterator = bank_sockets.begin();
//						iterator != bank_sockets.end(); iterator++)
//					if (clients[i] == (*iterator).second) {
//						chanel_id = (*iterator).first;
//						break;
//					}
//
//				//podle id pobocky zvednu seq num
//				if (chanel_id == other1_id) {
//					message.sequence = sequence_num1;
//					sequence_num1++;
//				} else {
//					message.sequence = sequence_num2;
//					sequence_num2++;
//				}
				send(clients[i], &message, sizeof(MESSAGE), 0);
				cout << "Sending MARKER to branch ID - " << chanel_id << "\n";
			}
			sentMarker = true;
			//globalState = false;

		} else {
			sleep(1 + (rand() % 5));

			if (!globalState) {
				int value = (rand() % 100) + 1;

				pthread_mutex_lock(&bank_mutex);
				if (amount - value > 0) {
					amount -= value;
					//write_marker(bank_id,account,false);
					int sock = clients[rand() % clients.size()];
//				cout << "Send transport to the other branch seq - "
//						<< currentAction << "\n";
					packet_send(sock, 1, value);
				}
			}
			pthread_mutex_unlock(&bank_mutex);
		}

	}
	return NULL;
}

void settingBranch(int port) {

	int portBanky = 10000;
	int client_socket;
	struct sockaddr_in my_addr;

	client_socket = socket(AF_INET, SOCK_STREAM, 0);

	my_addr.sin_family = AF_INET;
	my_addr.sin_port = htons(portBanky);
	my_addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (connect(client_socket, (struct sockaddr *) &my_addr,
			sizeof(struct sockaddr_in)) != 0) {
		cout << "The problem occurred during binding.\n";
		exit(EXIT_FAILURE);
	}
	cout << "Connect to bank...\n";
	bankaSocket = client_socket;

	BranchInfo info;
	info.port = port;

	send(bankaSocket, &info, sizeof(BranchInfo), 0);
	int receiveBytes = recv(bankaSocket, &info, sizeof(BranchInfo), 0);
	if (receiveBytes >= 0) {
		cout << "The branch ID : " << info.idBranch << "\n";
		branchId = info.idBranch;
	} else {
		cout << "The problem occurred during getting ID.\n";
		exit(EXIT_FAILURE);
	}

	fileLogBranch = "../log/log_branch" + numberToString(branchId) + ".txt";

	Branch newBranch;
	bool first = true;
	while (true) {
		int rec = recv(bankaSocket, &newBranch, sizeof(Branch), 0);

		if (rec > 0) {
			if (newBranch.idBranch == -1) {
				break;
			}

			if (newBranch.idBranch != branchId) {
				cout << "Registration new branch with ";
				cout << "socket - " << newBranch.branchSocket << " port - "
						<< newBranch.port << "\n";

				if (first) {
					other1_id = newBranch.idBranch;
					first = false;
				} else
					other2_id = newBranch.idBranch;

				branches.push_back(newBranch);
			}
		}
	}

}

void *start_worker(void *args) {

	int *pom = (int *) args;
	int worker_id = *pom;
	delete pom;

	vector<MESSAGE> *vect;
	int *exp;

	if (worker_id == other1_id) {
		vect = &other1;
		exp = &expected_other1;
	} else {
		vect = &other2;
		exp = &expected_other2;
	}

	while (true) {
		MESSAGE message;
		message.operation = 0;

		sleep(1);

		pthread_mutex_lock(&other_mutex);

		if (!vect->empty()) {
			//vyberu zpravu podle ocekavaneho cisla
			for (unsigned int i = 0; i < vect->size(); i++) {
				if (vect->at(i).sequence == *exp) {
					message = vect->at(i);
					vect->erase(vect->begin() + i);
					(*exp)++;
					break;
				}
			}
		}

//		if (message.operation == -1 && count != 2) {
//
//			message.recvTime = getTime();
//			writeToMarkerLog(message, branchId);
//
//			if (!setGlobal) {
//				observer_init();
//				setGlobal = true;
//				cout << "Setting global state\n";
//				globalState = true;
//				globalMoney = amount;
//			}
//			// for the second and third process
////			cout << "Receive a MARKER from the other branch seq "
////					<< message.sequence << "\n";
//			cout << "PROCESSING SEQ - " << message.sequence << "\n";
//			marked_chanels[message.from] = true;
//			count++;
//			if (count != 2)
//				message.operation = 0;
//		}
		pthread_mutex_unlock(&other_mutex);

		pthread_mutex_lock(&bank_mutex);

		if (globalState && message.operation != 0) {

//			if (is_marked_all_chanels() && sentMarker) {
//
//				message.recvTime = getTime();
//				writeToLog(message);
//				amount += message.value;
//				//globalMoney += message.value;
//
//				RequestGlobalStatue request;
//				request.currentMoney = globalMoney;
//				request.casOdeslani = getTime();
//				request.request = branchId;
//
//				send(bankaSocket, &request, sizeof(RequestGlobalStatue), 0);
//
//				cout << "Send global state to bank\n";
//
//				globalState = false;
//				sentMarker = false;
//				setGlobal = false;
//				globalMoney = 0;
//				count = 0;
//				map<int, bool>::iterator iterator;
//				for (iterator = marked_chanels.begin();
//						iterator != marked_chanels.end(); iterator++)
//					(*iterator).second = false;
//
//			} else {
			if (message.operation == 1) {
//					cout << "Receive a transport in global seq -"
//							<< message.sequence << "\n";
				cout << "PROCESSING SEQ - " << message.sequence << "\n";
				message.recvTime = getTime();
				writeToLog(message);
				amount += message.value;

				if (!marked_chanels[message.from]) {
					//cout << "plus do global - " << message.value << "\n";
					globalMoney += message.value;
				}
			}

//			}
		} else {
			if (message.operation == 1) {
				message.recvTime = getTime();
				writeToLog(message);
//				cout << "Receive a transport from the other branch seq -"
//						<< message.sequence << "\n";
				cout << "PROCESSING SEQ - " << message.sequence << "\n";
				amount += message.value;
			}
		}
		pthread_mutex_unlock(&bank_mutex);
		sleep(1);

	}

	return 0;
}

void *global_state(void *args) {

	RequestGlobalStatue request;

	while (true) {
		globalMoney = 0;
		int rec = recv(bankaSocket, &request, sizeof(RequestGlobalStatue), 0);
		if (rec > 0) {
			if (request.request == 1) {
				//cout << "Receive a request for global state\n";
				request.casPrijeti = getTime();
				observer_init();
				globalState = true;
				sentMarker = false;
//				setGlobal = true;
//				cout = 0;
				//cout << "Eviduju cash  - " << amount << "\n";
				pthread_mutex_lock(&bank_mutex);
				globalMoney = amount;
				pthread_mutex_unlock(&bank_mutex);
				writeToGlobalStartLog(request, branchId);

//				request.currentMoney = globalMoney;
//				request.request = branchId;
//				send(bankaSocket, &request, sizeof(RequestGlobalStatue), 0);
			}
		}
	}

	return 0;
}

int main(int argc, char* argv[]) {

	struct timeval t1;
	gettimeofday(&t1, NULL);
	srand(t1.tv_usec * t1.tv_sec);
	pthread_mutex_init(&bank_mutex, NULL);
	pthread_mutex_init(&other_mutex, NULL);
	pthread_mutex_init(&log_mutex, NULL);
	port = strtol(argv[1], NULL, 10);
	pthread_t server_thread;
	pthread_t client_thread;
	pthread_t worker1, worker2;
	pthread_t globalState;

	settingBranch(port);
	//cout << "Branch has been set...\n";

// start new server thread
	pthread_create(&server_thread, NULL, server_thread_run, NULL);
	//cout << "Server started...\n";
	sleep(5);

	client_parse_and_connect();
	//cout << "All branches connected...\n";

	pthread_create(&client_thread, NULL, client_thread_run, NULL);
//	marker_start();
	int *id1 = new int;
	int *id2 = new int;

	*id1 = other1_id;
	*id2 = other2_id;

	pthread_create(&worker1, NULL, &start_worker, id1);
	pthread_create(&worker2, NULL, &start_worker, id2);
	//pthread_create(&worker, NULL, &start_worker, NULL);

	if (branchId == 1) {
		pthread_create(&globalState, NULL, &global_state, NULL);
		pthread_join(globalState, NULL);
	}
	pthread_join(server_thread, NULL);
	pthread_join(client_thread, NULL);
	pthread_join(worker1, NULL);
	pthread_join(worker2, NULL);
	for (unsigned int i = 0; i < bank_threads.size(); i++) {
		pthread_join(bank_threads[i], NULL);
	}

	return 0;
}

